<?php
namespace Avaliacao\Entities;

use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;


class Questipoaval extends Base\Questipoaval
{
    public static function insereQuestoesQuestipoaval($nrorg, $nrtipoavaliacao, $nrquestao)
    {
        try {
            $obj = self::getObjectByWhere(
                "NRORG = ? AND NRTIPOAVALIACAO = ? AND NRQUESTAO = ?",
                array($nrorg, $nrtipoavaliacao, $nrquestao)
            );
            if (empty($obj) === true) {
                $obj = new self();
                $obj->setNrquestipoaval(NovoCodigo::geraCodigo($nrorg, 'QUESTIPOAVAL',1,10,true));
                $obj->setNrquestao($nrquestao);
                $obj->setNrorg($nrorg);
                $obj->setIdativo('S');
                $obj->setDtinclusao(DateUtil::getDataAtual());
                $obj->setNrorginclusao($nrorg);
                $obj->setDtultatu(DateUtil::getDataAtual());
                $obj->setNrorgultatu($nrorg);
                $obj->setNrtipoavaliacao($nrtipoavaliacao);
                //
                $obj->persist();
                Registry::getEntityManager()->flush();
            }
            return true;
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }

    }

    public static function atualizaQuestoesQuestipoaval(
        $nrorg, $nrtipoavaliacao, $nrquestao, $nrquestipoaval
    ) {
        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRQUESTAO = ? AND NRQUESTIPOAVAL = ?',
                array($nrorg, $nrquestao, $nrquestipoaval)
            );
            //
            if ($obj instanceof Questipoaval) {
                $obj->setNrtipoavaliacao($nrtipoavaliacao);
                $obj->persist();
            }
            //
            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    public static function consultaQuestoesQuestipoaval($nrorg, $nrtipoavaliacao)
    {
        $objs = self::getObjectsByWhere(
            'NRORG = ? AND NRTIPOAVALIACAO = ?',
            array(
                $nrorg,
                $nrtipoavaliacao,
            )
        );
        return $objs;
    }

    public static function deletaRegistro($reg) {
        $connection = Registry::getEntityManager();
        //
        try {
            $connection->beginTransaction();
            //
            if ($reg instanceof self) {
                $reg->delete();
            }
            //
            $connection->flush();
            $connection->commit();
        } catch(\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }
}