<?php
/**
 * Created by JetBrains PhpStorm.
 * User: leonardocarvalho
 * Date: 30/08/13
 * Time: 14:15
 * To change this template use File | Settings | File Templates.
 */

namespace BancoTalentos\Logic\Mail;

require_once 'Zend/Mail.php';
require_once 'Zend/Mail/Transport/Smtp.php';

class Mail {

    private $_mailConfig;

    public function __construct($to, $subject, $content) {

        $this->_mailConfig = new Config($to, $subject, $content);

        try {

            // Definindo os parâmetros de configuração do SMTP
            $config = array (
                'auth' => $this->_mailConfig->getAuth(),
                'username' => $this->_mailConfig->getUsername(),
                'password' => $this->_mailConfig->getPassword()
            );

            // Enviando o email
            $mailTransport = new \Zend_Mail_Transport_Smtp($this->_mailConfig->getServer(), $config);
            \Zend_Mail::setDefaultTransport($mailTransport);
            $mail = new \Zend_Mail();
            $mail->setFrom($this->_mailConfig->getFrom());
            $mail->addTo($this->_mailConfig->getTo());
            $mail->setBodyHtml(utf8_decode($this->_mailConfig->getContent())); // Conteúdo no formato HTML
            //$mail->setBodyText(utf8_decode($this->_mailConfig->getContent())); // Conteúdo no formato texto padrão
            $mail->setSubject(utf8_decode($this->_mailConfig->getSubject()));
            $mail->send($mailTransport);

            tk_message('Email enviado com SUCESSSO!', 'success', 3000);

        } catch (\Exception $e){

            $error = 'Ops! Não foi possível enviar o email, informe ao administrador o seguinte erro: ' . $e->getMessage();
            tk_message($error, 'warning');

        }

    }

    /**
     * Processa a requisição de uma nova senha
     * @param string $nmacesso
     * @param string $nrorg
     * @author rodrigomarques
     * @deprecated
     */
//    public static function processNewPassword($nmacesso, $nrorg) {
//        $newPassword = self::getNewPassword();
//        $mailOper = Mercadum_Model_Operador::getEmailOper($nmacesso, $nrorg);
//        if(is_null($mailOper)) {
//            throw new Exception(UNKNOWN_MAIL_OPER);
//        }
//        $subject = 'Requisicao de senha';
//        $bodyText = "Sua nova senha: $newPassword";
//        Mercadum_Model_Operador::updatePassword($nmacesso, $nrorg, $newPassword);
//        // Mercadum_Util::sendMail($mailOper, $subject, $bodyText);
//    }

    /**
     * Retorna uma senha aleatória de 10 dígitos
     * @return integer
     * @author rodrigomarques
     */
    public static function getNewPassword() {
        $password =  rand(0,9).chr(rand(ord("a"), ord("z"))).
            rand(0,9).chr(rand(ord("A"), ord("Z"))).
            rand(0,9).chr(rand(ord("a"), ord("z")));

        return $password;
    }

    /**
     * Criptografa a senha do operador
     * @param string $cdsenhoper
     * @return string
     * @author rodrigomarques
     */
    public static function encrypts($cdsenhoper) {
        return sha1($cdsenhoper);
    }

}