CREATE OR REPLACE TRIGGER LOG_DFS_AUTOOBTERXMLGER
AFTER UPDATE OR INSERT OR DELETE
ON AUTOOBTERXMLGER FOR EACH ROW
DECLARE
  V_TIPO         VARCHAR2(1);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
BEGIN
   /*IDTIPOOPER - '1' - Incluso, 
                  '2' - Alterao, 
                  '3' - Excluso*/

   V_TIPO       := '0';
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.NRINSJURAUTOXML IS NOT NULL THEN
         V_DESC := V_DESC || ' NrInsJurAutoXML=' || :OLD.NRINSJURAUTOXML;
      END IF;

      IF :OLD.DSOBSAUTOXML IS NOT NULL THEN
         V_DESC := V_DESC || ' DsObsAutoXML=' || :OLD.DSOBSAUTOXML;
      END IF;

      V_TIPO   := '3';
      V_ITPESQ := :OLD.NRINSJURAUTOXML;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.NRINSJURAUTOXML,'!') <> NVL(:NEW.NRINSJURAUTOXML,'!')) OR
            (NVL(:OLD.DSOBSAUTOXML,'!')    <> NVL(:NEW.DSOBSAUTOXML,'!'))    THEN

            IF NVL(:NEW.NRINSJURAUTOXML, '!') <> NVL(:OLD.NRINSJURAUTOXML, '!') THEN
               V_DESC := V_DESC||' NrInsJurAutoXML='  || :NEW.NRINSJURAUTOXML;
            END IF;

            IF :NEW.DSOBSAUTOXML <> :OLD.DSOBSAUTOXML THEN
               V_DESC := V_DESC||' DsObsAutoXML='  || :NEW.DSOBSAUTOXML;
            END IF;

            V_TIPO   := '2';
            V_ITPESQ := :OLD.NRINSJURAUTOXML;
         END IF;
      ELSE
         IF NVL(:NEW.NRINSJURAUTOXML, '!') <> NVL(:OLD.NRINSJURAUTOXML, '!') THEN
            V_DESC := V_DESC||' NrInsJurAutoXML='  || :NEW.NRINSJURAUTOXML;
         END IF;

         IF NVL(:NEW.DSOBSAUTOXML, '!') <> NVL(:OLD.DSOBSAUTOXML, '!') THEN
            V_DESC := V_DESC||' DsObsAutoXML='  || :NEW.DSOBSAUTOXML;
         END IF;

         V_TIPO   := '1';
         V_ITPESQ := :NEW.NRINSJURAUTOXML;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 400);

   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         INSERT INTO LOGOPERA
            (NMTABELA,
             DTOPERACAO,
             NMRESPOPER,
             IDTIPOOPER,
             DSOPERACAO,
             CDPESQITEM,
             DSRDMUSUOPER,
             DSENDUSUOPER,
             DSNMUSUOPER,
             DSMETUSUOPER,
             CDORESPOPER)
         VALUES
            ('AUTOOBTERXMLGER',
             SYSDATE,
             NVL(V_NMOPERADOR,' '),
             V_TIPO,
             V_DESC,
             V_ITPESQ,
             V_DSSERVERRDM,
             V_DSREMOTEADDR,
             V_DSREMOTEHOST,
             V_DSSERVMETHOD,
             V_DSREMOTEOPER);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_DFS_AUTOOBTERXMLGER','5.85.xxx'); END;
/
